% Programm aufg34 zur linearen bzw. logarithmisch lin. Regression
% input:  Tabelle x_11 x_12 ... x_1n  y_1
%                 ...                    , d.h. Matrix x(m,n), Vektor y(m,1)
%                 x_m1 x_m2 ... x_mn  y_m
%         Wahlparameter rtyp (0 --> lin. Regr., .ne. 0 -->  log.lin. Regr.)
% output: Koeffizienten r_0, r_1,...,r_n, Residuenvektor d
% verwendete Programme: qr_gb.m, bestapprqr_gb
% aufruf: [r,d] = aufg34(x,y,rtyp);
function [r,d] = aufg34(x,y,rtyp);
m = length(x(:,1));
n = length(x(1,:)); n1 = n+1;
if (m < n || m == n)
  printf('zu wenig Messungen/Daten fuer die Regression');
  return
end
c = zeros(m,n1);
if (rtyp == 0)
% lineare Regression
  for i=1:m
    c0(i,1)=1;
    for j=1:n
      c0(i,j+1)=x(i,j);
    end
  end
  [c,t] = qr_gb(c0);
  [r,d] = bestapprqr_gb(c,t,y);
else
  itest = 0;
  for i=1:m
    if (y(i) < 0)
      itest = 1;
    end
    for j=1:n
      if (x(i,j) < 0)
        itest = 1;
      end
    end
  end
  if (itest == 1)
    printf('Daten nicht vollst. positiv, Abbruch');
    return
  end
  for i=1:m
    c0(i,1)=1;
    b(i)=log(y(i));
    for j=1:n
      c0(i,j+1)=log(x(i,j));
    end
  end
  [c,t] = qr_gb(c0);
  [r,d] = bestapprqr_gb(c,t,b);
  r(1) = exp(r(1));
end
end % function
