% Programm 5.3
% zur sukzessiven Berechnung der Stuetzkoeffizienten
% fuer die Polynomappr. fuer die Stuetzpunkte (x_0,y_0),...,(x_n,y_n)
% und Polynomwert-Berechnung mit der baryzentrischen Formel
% input:  Vektoren x(1:n+1), y(1:n+1), Stelle xx
% output: Wert des Lagrange-Polynoms p_n(xx)
% Aufruf: [fwert] = lagrangebaryip_gb(xx,x,y)
function [fwert] = lagrangebaryip_gb(xx,x,y)
n = length(x)-1;
% Start mit lambda_0
lambda(1) = 1;
for k=1:n
  summe = 0.0;
% Berechnung der Stuetzkoeffizienten
  for i=0:k-1
    lambda(i+1) = lambda(i+1)/(x(i+1)-x(k+1));
    summe = summe + lambda(i+1);
  end
  lambda(k+1) = -summe;
% Berechnung des Interpolationspolynoms an der Stelle xx
  summe = 0.0; zaehler = 0.0;
  for i=0:k
    mue = lambda(i+1)/(xx-x(i+1));
    summe = summe + mue;
    zaehler = zaehler + mue*y(i+1);
  end
end
% Polynomwert mit der baryzentrischen Formel an der Stelle xx
fwert = zaehler/summe;
end % function
